diff --git a/Makefile.am b/Makefile.am
index 4e9cae885..52e0e9ed8 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -345,7 +345,7 @@ CLEANFILES += $(builtin_files) src/bluetooth.service
 if MANPAGES
 man_MANS += src/bluetoothd.8
 endif
-EXTRA_DIST += src/bluetoothd.8
+manual_pages += src/bluetoothd.8
 
 EXTRA_DIST += src/genbuiltin src/bluetooth.conf \
 			src/main.conf profiles/network/network.conf \
@@ -631,6 +631,9 @@ endif
 %.1: %.rst Makefile
 	$(RST2MAN_PROCESS)
 
+%.8: %.rst Makefile
+	$(RST2MAN_PROCESS)
+
 src/builtin.h: src/genbuiltin $(builtin_sources)
 	$(AM_V_GEN)$(srcdir)/src/genbuiltin $(builtin_modules) > $@
 
diff --git a/configure.ac b/configure.ac
index d7e4766e4..f445589b0 100644
--- a/configure.ac
+++ b/configure.ac
@@ -412,4 +412,4 @@ fi
 AC_DEFINE_UNQUOTED(ANDROID_STORAGEDIR, "${storagedir}/android",
 			[Directory for the Android daemon storage files])
 
-AC_OUTPUT(Makefile src/bluetoothd.8 lib/bluez.pc)
+AC_OUTPUT(Makefile src/bluetoothd.rst lib/bluez.pc)
diff --git a/src/bluetoothd.8.in b/src/bluetoothd.8.in
deleted file mode 100644
index d61dcc5b3..000000000
--- a/src/bluetoothd.8.in
+++ /dev/null
@@ -1,63 +0,0 @@
-.\"
-.TH "BLUETOOTHD" "8" "March 2004" "Bluetooth daemon" "System management commands"
-.SH "NAME"
-bluetoothd \- Bluetooth daemon
-
-.SH "SYNOPSIS"
-.B bluetoothd [--version] | [--help]
-
-.B bluetoothd [--nodetach] [--compat] [--experimental] [--debug=<files>] [--plugin=<plugins>] [--noplugin=<plugins>]
-
-.SH "DESCRIPTION"
-This manual page documents briefly the
-.B bluetoothd
-daemon, which manages all the Bluetooth devices.
-.B bluetoothd
-can also provide a number of services via the D-Bus message bus
-system.
-.SH "OPTIONS"
-.TP
-.B -v, --version
-Print bluetoothd version and exit.
-.TP
-.B -h, --help
-Print bluetoothd options and exit.
-.TP
-.B -n, --nodetach
-Enable logging in foreground. Directs log output to the controlling terminal \
-in addition to syslog.
-.TP
-.B -f, --configfile
-Specifies an explicit config file path instead of relying on the default path \
-(@CONFIGDIR@/main.conf) for the config file.
-.TP
-.B -d, --debug=<file1>:<file2>:...
-Sets how much information bluetoothd sends to the log destination (usually \
-syslog's "daemon" facility). If the file options are omitted, then debugging \
-information from all the source files are printed. If file options are \
-present, then only debug prints from that source file are printed. The option \
-can be a pattern containing "*" and "?" characters.
-
-Example: --debug=src/adapter.c:src/agent.c
-.TP
-.B -p, --plugin=<plugin1>,<plugin2>,..
-Load these plugins only. The option can be a pattern containing "*" and "?" \
-characters.
-.TP
-.B -P, --noplugin=<plugin1>,<plugin2>,..
-Never load these plugins. The option can be a pattern containing "*" and "?" \
-characters.
-.TP
-.B -C, --compat
-Provide deprecated command line interfaces.
-.TP
-.B -E, --experimental
-Enable experimental interfaces. Those interfaces are not guaranteed to be
-compatible or present in future releases.
-.SH "FILES"
-.TP
-.I @CONFIGDIR@/main.conf
-Location of the global configuration file.
-
-.SH "AUTHOR"
-This manual page was written by Marcel Holtmann, Philipp Matthias Hahn and Fredrik Noring.
diff --git a/src/bluetoothd.rst.in b/src/bluetoothd.rst.in
new file mode 100644
index 000000000..6bce349ef
--- /dev/null
+++ b/src/bluetoothd.rst.in
@@ -0,0 +1,84 @@
+==========
+bluetoothd
+==========
+
+----------------
+Bluetooth daemon
+----------------
+
+:Authors: - Marcel Holtmann
+          - Philipp Matthias Hahn
+          - Fredrik Noring
+:Version: BlueZ
+:Copyright: Free use of this software is granted under ther terms of the GNU
+            Lesser General Public Licenses (LGPL).
+:Date: March, 2004
+:Manual section: 8
+:Manual group: System management commands
+
+SYNOPSIS
+========
+
+**bluetoothd** [--version] | [--help]
+
+**bluetoothd**  [--nodetach]  [--compat] [--experimental] [--debug=<*files*>]
+[--plugin=<*plugins*>] [--noplugin=<*plugins*>]
+
+DESCRIPTION
+===========
+
+This manual page documents briefly the **bluetoothd** daemon, which manages
+all the Bluetooth devices. **bluetoothd** can also provide a number of services
+via the D-Bus message bus system.
+
+OPTIONS
+=======
+
+-v, --version       Print bluetoothd version and exit.
+
+-h, --help          Print bluetoothd options and exit.
+
+-n, --nodetach      Enable logging in foreground. Directs log output to the
+                    controlling terminal in addition to syslog.
+
+-f, --configfile    Specifies an explicit config file path instead of relying
+                    on the default path(*@CONFIGDIR@/main.conf*)
+                    for the config file.
+
+-d, --debug=<file1>:<file2>:...
+    Sets how much information bluetoothd sends to the log destination (usually
+    syslog's "daemon" facility). If the file options are omitted, then
+    debugging information from all the source files are printed. If file
+    options are present, then only debug prints from that source file are
+    printed. The option can be a pattern containing "*" and "?" characters.
+
+    Example: --debug=src/adapter.c:src/agent.c
+
+-p, --plugin=<plugin1>,<plugin2>,..
+    Load these plugins only. The option can be a pattern containing  "*" and
+    "?" characters.
+
+-P, --noplugin=<plugin1>,<plugin2>,..
+    Never load these plugins. The option can be a pattern containing "*" and
+    "?"  characters.
+
+-C, --compat        Provide deprecated command line interfaces.
+
+-E, --experimental  Enable experimental interfaces. Those interfaces are not
+                    guaranteed to be compatible or present in future releases.
+
+FILES
+=====
+
+*@CONFIGDIR@/main.conf*
+    Location of the global configuration file.
+
+RESOURCES
+=========
+
+http://www.bluez.org
+
+REPORTING BUGS
+==============
+
+linux-bluetooth@vger.kernel.org